//
// Created by trotfunky on 06/06/19.
//

#ifndef SRC_GAME_H
#define SRC_GAME_H

#include <SFML/Graphics.hpp>
#include <vector>
#include <iostream>

#include "Level.h"
#include "Entity.h"
#include "Utils.h"


class Game {
public:
    Game(std::vector<std::string>& levels, std::vector<std::string>& textures);

    /// Loads the level of corresponding ID from Game::levelFiles
    /// Closes the program if there is a fatal error (Missing file, bad file...)
    void loadLevel(int levelId);

    std::unique_ptr<Level> currentLevel;

    // This should not be called before a level has been loaded
    void runGame();

    explicit operator bool() const;

private:
    /// Store the paths to level files
    const std::vector<std::string> levelFiles;
    /// Store the paths to texture files
    const std::vector<std::string> textureFiles;
    /// Stores pointers to textures for future use
    pro_maat::TextureStore textures;

    void loadTextures();
};


#endif //SRC_GAME_H
